//+------------------------------------------------------------------+
//|                                                        iUSDx.mqh |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                              Revision 2010.12.17 |
//+------------------------------------------------------------------+

// Structure to serve the information on symbol and it weight
struct stCurrencyWeight
{
   string symbol;   // Symbol
   double weight;   // Weight
};

class CUSDx
  {
   protected:
      string   m_symbol;            // Symbol
      int      m_currency_base;     // Base currency
      double   m_currency_weight;   // Currency weight in the basket
      bool     m_init_flag;
   public:
      double   buffer[];            // indicator buffer

      void     CUSDx();
      void     SetCurrencyAndWeight(string symbol, double weight);
      void     InitSymbol(int count_symbol, string currency, string symbol);
      void     USDxSymbol(int bar=0);
      bool     GetInit() {return(m_init_flag);}
  };

void CUSDx::CUSDx()
  {
   m_init_flag=false;
  }
  
//+------------------------------------------------------------------+
//|          |
//| INPUT:  symbol - ;                                         |
//|         weight -  .                             |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CUSDx::SetCurrencyAndWeight(string symbol, double weight)
  {
   m_symbol=symbol;
   m_currency_weight=weight;
  }

//+------------------------------------------------------------------+
//|                   |
//| INPUT:  count_symbol   -    ;         |
//|         currency_index -  ;                         |
//|         symbol         -                                   |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CUSDx::InitSymbol(int count_symbol, string currency_index, string symbol)
  {   
   m_init_flag=true;
   
   if(currency_index==SymbolInfoString(m_symbol,SYMBOL_CURRENCY_BASE)) m_currency_base=1;
   else if(currency_index==SymbolInfoString(m_symbol,SYMBOL_CURRENCY_PROFIT)) m_currency_base=-1;
        else m_currency_base=0;

   ArraySetAsSeries(buffer,true);  // set indexation as time series
   
   for(int bar=count_symbol-1; bar>=0; bar--) USDxSymbol(bar);
     
   return;
  }
  
//+------------------------------------------------------------------+
//| Method for calculation of contribution of symbol to the Index    |
//| INPUT:  bar - bar index.                                         |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CUSDx::USDxSymbol(int bar=0)
  {
   buffer[bar]=EMPTY_VALUE;
   if(m_currency_base==0) return;
     
   // get bar time:
   datetime time[1];      
   if(CopyTime(_Symbol,_Period,bar,1,time)!=1) return; // wait new tick if error...

   // get the closing price of the bar with the current bar time:
   double price[1];
   if(CopyClose(m_symbol,_Period,time[0],time[0],price)!=1) return; // wait new tick if error...

   buffer[bar]=MathPow(price[0],m_currency_base*m_currency_weight);
   return;
  }

